<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<title>zh-tw/HowTos/BuildingKernelModules</title>
<link rel="stylesheet" type="text/css" media="all" charset="utf-8" href="modern/css/common.css">
<link rel="stylesheet" type="text/css" media="screen" charset="utf-8" href="modern/css/screen.css">
<link rel="stylesheet" type="text/css" media="print" charset="utf-8" href="modern/css/print.css">
<style type="text/css">
ul.pagetitle{
  display: inline;
  margin: 0;
  padding: 0;
  font-size: 1.5em;
}
li.pagetitle{
  display: inline;
  margin: 0;
}
td.noborder {
  border: 0;
}
</style>
</head>
<body>
<table>
<tr>
<td class="noborder">
<img src="logo.png">
</td>
<td class="noborder">
<ul class="pagetitle">
<li class="pagetitle"><a class="backlink">zh-tw/HowTos/BuildingKernelModules</a>
</ul>
<br><br>
[<a href="FrontPage.html">FrontPage</a>]&nbsp;[<a href="TitleIndex.html">TitleIndex</a>]&nbsp;[<a href="WordIndex.html">WordIndex</a>]&nbsp;
</td>
</tr>
</table>
<hr>
<div id="page"><h1 style="background-color:Red; color:White">This is a read-only <a href="https://gitlab.com/CentOS/docs/wiki_archives">archived version</a> of wiki.centos.org</h1>
<div dir="ltr" id="content" lang="zh-tw"><span class="anchor" id="top"></span>
<span class="anchor" id="line-1"></span><span class="anchor" id="line-2"></span><span class="anchor" id="line-3"></span><span class="anchor" id="line-4"></span><p class="line867">
<h1 id="A.2BXvp6y09ggepd8XaEUWdoOGohWEo-">建立你自己的內核模塊</h1>
<span class="anchor" id="line-5"></span><p class="line862">英文版本由 <a href="./AkemiYagi.html">AkemiYagi</a> 建立。現時由 <a href="./AlanBartlett.html">AlanBartlett</a> 及 <a href="./AkemiYagi.html">AkemiYagi</a> 維護。 <span class="anchor" id="line-6"></span><div><table><tbody><tr>  <td style="background-color: #ff0000"><p class="line862">請注意，假若你修改你的內核，你將不再穫得 CentOS 開發小組的支援或幫助。這裡所描述的步驟並沒有 CentOS 的官方認可。這個教學文檔的原意是要幫助你建立自己的內核模塊。 </td>
</tr>
</tbody></table></div><span class="anchor" id="line-7"></span><span class="anchor" id="line-8"></span><div><table><tbody><tr>  <td class="lmimg blue" style="padding: 0pt;"><p class="line862"> <a class="attachment" href="attachments/ArtWork(2f)WikiDesign/icon-admonition-info.png" title="{{attachment:ArtWork/WikiDesign/icon-admonition-info.png}}"><img alt="attachment:ArtWork/WikiDesign/icon-admonition-info.png" class="attachment" src="attachments/ArtWork(2f)WikiDesign/icon-admonition-info.png" title="attachment:ArtWork/WikiDesign/icon-admonition-info.png" /></a> </td>
  <td class="lmtxt blue" colspan="2" style="padding: 0pt;  text-align: left;  vertical-align: top;"><p class="line862">要是你將會在採用 Secure Boot 的系統上安裝自己的模塊，你須要以私鑰簽署該模塊。詳情見 <a class="https" href="https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/Kernel_Administration_Guide/sect-signing-kernel-modules-for-secure-boot.html">Signing Kernel Modules for Secure Boot</a>。</td>
</tr>
</tbody></table></div><span class="anchor" id="line-9"></span><span class="anchor" id="line-10"></span><p class="line867"><div class="table-of-contents"><p class="table-of-contents-heading">Contents<ol><li>
<a href="#A.2BXvp6y04AUAtRZ2g4aiFYSv8I.2A.ko.2B.2Fwk-">建立一個內核模塊（*.ko）</a></li><li>
<a href="#A.2BUil1KFLVYUtRZ2g4aiFYSmUvY.2FT.2FCA-DKMS.2B.2Fwle.2BnrLTgBQC1FnaDhqIVhK-">利用動態內核模塊支援（DKMS）建立一個內核模塊</a></li><li>
<a href="#A.2BXvp6y04AUAtRZ2g4aiFYSnaE_rpm_.2BWVdO9v8I-kmod.2B.2Fwk-">建立一個內核模塊的 rpm 套件（kmod）</a></li></ol></li></ol></div> <span class="anchor" id="line-11"></span><span class="anchor" id="line-12"></span><p class="line867"><img alt="/!\" height="16" src="/moin_static1911/modern/img/alert.png" title="/!\" width="16" /> 本教學文檔以 CentOS-7 作為範例操作系統。 <span class="anchor" id="line-13"></span><span class="anchor" id="line-14"></span><p class="line874">在某些情況下你也許會需要更改或建立一個新的內核模塊。也許你要加入某個功能，或者只是做一個修正。在這件教學文檔內，我們會嘗試將一個錯誤修正加進現有的模塊內，然後安裝它。 <span class="anchor" id="line-15"></span><span class="anchor" id="line-16"></span><p class="line862">這裡假設你已經安裝了整個內核的源代碼。如果你是按照<a href="./zh(2d)tw(2f)HowTos(2f)I_need_the_Kernel_Source.html">「我需要內核的源代碼」</a>的第 2 部份，它會位於 <tt class="backtick">~/rpmbuild/BUILD/kernel-3.10.0/linux-3.10.0.</tt><tt>`uname&nbsp;-m`</tt><tt class="backtick">/</tt> 這個目錄內。 <span class="anchor" id="line-17"></span><span class="anchor" id="line-18"></span><p class="line867"><img alt="/!\" height="16" src="/moin_static1911/modern/img/alert.png" title="/!\" width="16" /> 我們<strong>強烈</strong>地<strong>反對</strong>你以 root 用戶來建立模塊。（見：<a class="http" href="http://www.owlriver.com/tips/non-root/">Building Source RPM as non-root under CentOS</a>） <span class="anchor" id="line-19"></span><span class="anchor" id="line-20"></span><p class="line867">
<h2 id="A.2BXvp6y04AUAtRZ2g4aiFYSv8I.2A.ko.2B.2Fwk-">1. 建立一個內核模塊（*.ko）</h2>
<span class="anchor" id="line-21"></span><span class="anchor" id="line-22"></span><p class="line862">設我們假設，作為一個範例，你將會針對位於 <tt class="backtick">~/rpmbuild/BUILD/kernel-3.10.0/linux-3.10.0-957.x86_64/fs/cifs/</tt> 目錄內的 cif 模塊加入修正。 <span class="anchor" id="line-23"></span><span class="anchor" id="line-24"></span><p class="line874">1. 針對源代碼檔進行所需的修正。 <span class="anchor" id="line-25"></span><span class="anchor" id="line-26"></span><p class="line862">2. 進到<strong>內核源代碼的主目錄</strong>。如果這次是內核首次被編譯，請設定內核，並謹記在設定檔（.conf）內將相關的元件設為模塊。 <span class="anchor" id="line-27"></span><span class="anchor" id="line-28"></span><p class="line867"><span class="anchor" id="line-29"></span><span class="anchor" id="line-30"></span><span class="anchor" id="line-31"></span><span class="anchor" id="line-32"></span><pre><span class="anchor" id="line-1"></span>[user@host]$ cd ~/rpmbuild/BUILD/kernel-3.10.0/linux-3.10.0-957.x86_64
<span class="anchor" id="line-2"></span>[user@host linux-3.10.0-957.x86_64]$ make oldconfig
<span class="anchor" id="line-3"></span>[user@host linux-3.10.0-957.x86_64]$ make prepare</pre><span class="anchor" id="line-33"></span><p class="line874">3. 建立編譯外置模塊時所需的檔案。 <span class="anchor" id="line-34"></span><span class="anchor" id="line-35"></span><p class="line867"><span class="anchor" id="line-36"></span><span class="anchor" id="line-37"></span><pre><span class="anchor" id="line-1-1"></span>[user@host linux-3.10.0-957.x86_64]$ make modules_prepare</pre><span class="anchor" id="line-38"></span><span class="anchor" id="line-39"></span><p class="line874">4. 透過指定模塊的 Makefile 及源代碼的相對路徑來編譯模塊。 <span class="anchor" id="line-40"></span><span class="anchor" id="line-41"></span><p class="line867"><span class="anchor" id="line-42"></span><span class="anchor" id="line-43"></span><pre><span class="anchor" id="line-1-2"></span>[user@host linux-3.10.0-957.x86_64]$ make M=fs/cifs</pre><span class="anchor" id="line-44"></span><p class="line862">註：藏有模塊的目錄可以位於任何一個位置。舉個例說，假如它位於 <tt class="backtick">~/mycifs/</tt>，你可以在<strong>內核源代碼的主目錄</strong>裡執行以下的指令： <span class="anchor" id="line-45"></span><span class="anchor" id="line-46"></span><p class="line867"><span class="anchor" id="line-47"></span><span class="anchor" id="line-48"></span><pre><span class="anchor" id="line-1-3"></span>[user@host linux-3.10.0-957.x86_64]$ make M=~/mycifs</pre><span class="anchor" id="line-49"></span><p class="line874">5. 除非你編譯這個模塊作偵錯用途，否則你應該移除不必要的符號。 <span class="anchor" id="line-50"></span><span class="anchor" id="line-51"></span><p class="line867"><span class="anchor" id="line-52"></span><span class="anchor" id="line-53"></span><pre><span class="anchor" id="line-1-4"></span>[user@host linux-3.10.0-957.x86_64]$ strip --strip-debug fs/cifs/cifs.ko</pre><span class="anchor" id="line-54"></span><p class="line862">6. 這個範例建立了 cifs.ko 這個檔案。請以 <strong>root</strong> 的身份將 .ko 檔案複製到 /lib/modules/&lt;<em>內核版本</em>&gt;/extra/ 目錄內。 <span class="anchor" id="line-55"></span><span class="anchor" id="line-56"></span><p class="line867"><span class="anchor" id="line-57"></span><span class="anchor" id="line-58"></span><pre><span class="anchor" id="line-1-5"></span>[root@host linux-3.10.0-957.x86_64]# cp fs/cifs/cifs.ko /lib/modules/`uname -r`/extra</pre><span class="anchor" id="line-59"></span><span class="anchor" id="line-60"></span><p class="line862">7. 以 <strong>root</strong> 的身份執行 depmod 指令來更新模塊的依賴檔。 <span class="anchor" id="line-61"></span><span class="anchor" id="line-62"></span><p class="line867"><span class="anchor" id="line-63"></span><span class="anchor" id="line-64"></span><pre><span class="anchor" id="line-1-6"></span>[root@host linux-3.10.0-957.x86_64]# depmod -a</pre><span class="anchor" id="line-65"></span><span class="anchor" id="line-66"></span><p class="line867">
<h2 id="A.2BUil1KFLVYUtRZ2g4aiFYSmUvY.2FT.2FCA-DKMS.2B.2Fwle.2BnrLTgBQC1FnaDhqIVhK-">2. 利用動態內核模塊支援（DKMS）建立一個內核模塊</h2>
<span class="anchor" id="line-67"></span><span class="anchor" id="line-68"></span><p class="line874">上面所描述的方法是為某個特定的內核版本建立一個模塊。一旦你將內核升級或者更改硬件的架構，你將會須要將模塊重新建立。動態內核模塊支援（DKMS）這個架構基本上是在內核源代碼以外的地方複製一棵目錄樹，當中藏有某個模塊的源代碼及編譯了的二進制程式。DKMS 可以用來建立、安裝及解除安裝模塊。DKMS 需要在系統上找到模塊的源代碼。DKMS 程式庫亦能代你建立及安裝模塊到你系統上的任何內核裡。 <span class="anchor" id="line-69"></span><span class="anchor" id="line-70"></span><p class="line862">在這裡我們會採用與上面相同的範例來建立及安裝 <tt class="backtick">cifs</tt> 這個模塊。在下面整個部份，你都須要有 <strong>root</strong> 的權限。 <span class="anchor" id="line-71"></span><span class="anchor" id="line-72"></span><p class="line862">1. 安裝<strong>所有</strong>與這個模塊的目標內核版本相乎的 <tt class="backtick">kernel-devel</tt> 套件。 <span class="anchor" id="line-73"></span><span class="anchor" id="line-74"></span><p class="line862">2. 安裝 EPEL 軟件庫（見 <a href="./zh(2d)tw(2f)Repositories.html">軟件庫</a>頁）內的 <tt class="backtick">dkms</tt> 套件。 <span class="anchor" id="line-75"></span><span class="anchor" id="line-76"></span><p class="line862">3. 建立一個 <tt class="backtick">/usr/src/&lt;模塊&gt;-&lt;模塊版本&gt;/</tt> 的目錄 <span class="anchor" id="line-77"></span><span class="anchor" id="line-78"></span><p class="line867"><span class="anchor" id="line-79"></span><span class="anchor" id="line-80"></span><pre><span class="anchor" id="line-1-7"></span>[root@host]# mkdir /usr/src/cifs-1.45fixed/</pre><span class="anchor" id="line-81"></span><p class="line874">4. 將模塊的源代碼複製到這個目錄。 <span class="anchor" id="line-82"></span><span class="anchor" id="line-83"></span><p class="line867"><span class="anchor" id="line-84"></span><span class="anchor" id="line-85"></span><span class="anchor" id="line-86"></span><pre><span class="anchor" id="line-1-8"></span>[root@host]# cd ~/rpmbuild/BUILD/kernel-2.6.18/linux-2.6.18-i686/fs/cifs
<span class="anchor" id="line-2-1"></span>[root@host cifs]# cp -a * /usr/src/cifs-1.45fixed/</pre><span class="anchor" id="line-87"></span><p class="line862">5. 在 <tt class="backtick">/usr/src/&lt;模塊&gt;-&lt;模塊版本&gt;/</tt> 這個目錄內建立 <tt class="backtick">dkms.conf</tt> 檔 <span class="anchor" id="line-88"></span><span class="anchor" id="line-89"></span><p class="line867"><span class="anchor" id="line-90"></span><span class="anchor" id="line-91"></span><span class="anchor" id="line-92"></span><pre><span class="anchor" id="line-1-9"></span>[root@host cifs]# cd /usr/src/cifs-1.45fixed
<span class="anchor" id="line-2-2"></span>[root@host cifs-1.45fixed]# vi dkms.conf</pre><span class="anchor" id="line-93"></span><p class="line867"><tt class="backtick">dkms.conf</tt> 檔須要包含以下內容： <span class="anchor" id="line-94"></span><span class="anchor" id="line-95"></span><p class="line867"><span class="anchor" id="line-96"></span><span class="anchor" id="line-97"></span><span class="anchor" id="line-98"></span><span class="anchor" id="line-99"></span><span class="anchor" id="line-100"></span><span class="anchor" id="line-101"></span><pre><span class="anchor" id="line-1-10"></span>PACKAGE_NAME="cifs"
<span class="anchor" id="line-2-3"></span>PACKAGE_VERSION="1.45fixed"
<span class="anchor" id="line-3-1"></span>BUILT_MODULE_NAME[0]="cifs"
<span class="anchor" id="line-4"></span>DEST_MODULE_LOCATION[0]="/kernel/fs/cifs/"
<span class="anchor" id="line-5"></span>AUTOINSTALL="yes"</pre><span class="anchor" id="line-102"></span><p class="line862">註：<tt class="backtick">DEST_MODULE_LOCATION</tt>[0] 這一行將會在安裝模塊時被忽視，因為它一定會是 /lib/modules/&lt;<em>內核版本</em>&gt;/extra/ 這個目錄。然而，這個參數卻指定當模塊被解除安裝時，舊有被儲存的模塊（假若有的話）應該被還原到哪個位置。 <span class="anchor" id="line-103"></span><span class="anchor" id="line-104"></span><p class="line862">6. 將 <tt class="backtick">&lt;模塊&gt;/&lt;模塊版本&gt;</tt> 加進 DKMS 的目錄樹。 <span class="anchor" id="line-105"></span><span class="anchor" id="line-106"></span><p class="line867"><span class="anchor" id="line-107"></span><span class="anchor" id="line-108"></span><pre><span class="anchor" id="line-1-11"></span>[root@host cifs-1.45fixed]# dkms add -m cifs -v 1.45fixed</pre><span class="anchor" id="line-109"></span><p class="line874">7. 在 DKMS 的控制下編譯模塊。 <span class="anchor" id="line-110"></span><span class="anchor" id="line-111"></span><p class="line867"><span class="anchor" id="line-112"></span><span class="anchor" id="line-113"></span><pre><span class="anchor" id="line-1-12"></span>[root@host cifs-1.45fixed]# dkms build -m cifs -v 1.45fixed</pre><span class="anchor" id="line-114"></span><p class="line874">8. 在 DKMS 的控制下安裝模塊。 <span class="anchor" id="line-115"></span><span class="anchor" id="line-116"></span><p class="line867"><span class="anchor" id="line-117"></span><span class="anchor" id="line-118"></span><pre><span class="anchor" id="line-1-13"></span>[root@host cifs-1.45fixed]# dkms install -m cifs -v 1.45fixed</pre><span class="anchor" id="line-119"></span><p class="line862">其它值得注意的 DKMS 動作包括 <tt class="backtick">uninstall</tt>、<tt class="backtick">remove</tt>、<tt class="backtick">status</tt> 及 <tt class="backtick">mkrpm</tt>。它們分別會將模塊從內核移除，將 <tt class="backtick">&lt;模塊&gt;/&lt;模塊版本&gt;</tt> 從 DKMS 目錄樹移除，顯示 DKMS 的現時狀況，及在 <tt class="backtick">/var/lib/dkms/&lt;模塊&gt;/&lt;模塊版本&gt;/rpm/</tt> 這個目錄內建立一個 rpm 檔案。 <span class="anchor" id="line-120"></span><span class="anchor" id="line-121"></span><p class="line874">請亦參閱： <span class="anchor" id="line-122"></span><span class="anchor" id="line-123"></span><ul><li><p class="line862">指令說明 <a class="http" href="http://linux.dell.com/dkms/manpage.html">http://linux.dell.com/dkms/manpage.html</a> <span class="anchor" id="line-124"></span></li><li><p class="line862">白皮書 <a class="http" href="http://linux.dell.com/dkms/dkms-ols2004.pdf">http://linux.dell.com/dkms/dkms-ols2004.pdf</a> <span class="anchor" id="line-125"></span><span class="anchor" id="line-126"></span></li></ul><p class="line867">
<h2 id="A.2BXvp6y04AUAtRZ2g4aiFYSnaE_rpm_.2BWVdO9v8I-kmod.2B.2Fwk-">3. 建立一個內核模塊的 rpm 套件（kmod）</h2>
<span class="anchor" id="line-127"></span><span class="anchor" id="line-128"></span><p class="line874">你亦可以為內核模塊建立 rpm 檔案。這個內核模塊的套件（kmod）便可以像其它套件一樣透過 rpm 指令來安裝。然而，包裝內核模塊的 rpm 與標準的包裝過程有不同的處理方法。以下的範例提供了基本的內核模塊 rpm 包裝技巧。 <span class="anchor" id="line-129"></span><span class="anchor" id="line-130"></span><p class="line874">再一次，我們會以 cifs 模塊作為範例來建立一套 kmod-cifs 的 rpm 檔。 <span class="anchor" id="line-131"></span><span class="anchor" id="line-132"></span><p class="line862">1. 安裝<strong>所有</strong>對應你現有內核的 <tt class="backtick">kernel-devel</tt> 套件。 <span class="anchor" id="line-133"></span><span class="anchor" id="line-134"></span><p class="line862">2. 正如上面的第 1 部份，已修正的源代碼位於 <tt class="backtick">~/rpmbuild/BUILD/kernel-2.6.18/linux-2.6.18.i686/fs/cifs/</tt> 這個目錄內。請複製這個目錄。 <span class="anchor" id="line-135"></span><span class="anchor" id="line-136"></span><p class="line867"><span class="anchor" id="line-137"></span><span class="anchor" id="line-138"></span><span class="anchor" id="line-139"></span><span class="anchor" id="line-140"></span><pre><span class="anchor" id="line-1-14"></span>[user@host]$ mkdir ~/cifs-1.45/
<span class="anchor" id="line-2-4"></span>[user@host]$ cd ~/rpmbuild/BUILD/kernel-2.6.18/linux-2.6.18.i686/fs/cifs
<span class="anchor" id="line-3-2"></span>[user@host]$ cp -a * ~/cifs-1.45/</pre><span class="anchor" id="line-141"></span><p class="line874">3. 建立一個藏有來源目錄的 bzip2 壓縮檔。 <span class="anchor" id="line-142"></span><span class="anchor" id="line-143"></span><p class="line867"><span class="anchor" id="line-144"></span><span class="anchor" id="line-145"></span><span class="anchor" id="line-146"></span><pre><span class="anchor" id="line-1-15"></span>[user@host]$ cd
<span class="anchor" id="line-2-5"></span>[user@host]$ tar -jcf cifs-1.45.tar.bz2 cifs-1.45/</pre><span class="anchor" id="line-147"></span><p class="line874">4. 將壓縮檔複製到 SOURCES 目錄內。 <span class="anchor" id="line-148"></span><span class="anchor" id="line-149"></span><p class="line867"><span class="anchor" id="line-150"></span><span class="anchor" id="line-151"></span><pre><span class="anchor" id="line-1-16"></span>[user@host]$ cp cifs-1.45.tar.bz2 ~/rpmbuild/SOURCES/</pre><span class="anchor" id="line-152"></span><p class="line862">5. 複製 <tt class="backtick">kmodtool</tt> 這個腳本（它是 <tt class="backtick">redhat-rpm-config</tt> 套件的一部份）到 SOURCES 目錄內。 <span class="anchor" id="line-153"></span><span class="anchor" id="line-154"></span><p class="line867"><span class="anchor" id="line-155"></span><span class="anchor" id="line-156"></span><span class="anchor" id="line-157"></span><pre><span class="anchor" id="line-1-17"></span>[user@host]$ cd ~/rpmbuild/SOURCES/
<span class="anchor" id="line-2-6"></span>[user@host SOURCES]$ cp /usr/lib/rpm/redhat/kmodtool kmodtool-cifs-el5.sh</pre><span class="anchor" id="line-158"></span><p class="line862">6. 編輯你所複製的 <tt class="backtick">kmodtool-cifs-el5.sh</tt> 檔案，並確定當中提及 <tt class="backtick">kmod-common</tt> 的行都被改為註釋。然後加入一行在 <em>%files</em> 內會擴充成指向 <tt class="backtick">kmod-cifs.conf</tt> 檔的指令。 <span class="anchor" id="line-159"></span><span class="anchor" id="line-160"></span><p class="line867"><span class="anchor" id="line-161"></span><span class="anchor" id="line-162"></span><pre><span class="anchor" id="line-1-18"></span>[user@host SOURCES]$ vi kmodtool-cifs-el5.sh</pre><span class="anchor" id="line-163"></span><p class="line874">由第 105 行起 —— <span class="anchor" id="line-164"></span><span class="anchor" id="line-165"></span><span class="anchor" id="line-166"></span><span class="anchor" id="line-167"></span><span class="anchor" id="line-168"></span><span class="anchor" id="line-169"></span><pre><span class="anchor" id="line-1-19"></span>#
<span class="anchor" id="line-2-7"></span># RHEL5 - Remove common package requirement on general kmod packages.
<span class="anchor" id="line-3-3"></span># Requires: ${kmod_name}-kmod-common &gt;= %{?epoch:%{epoch}:}%{version}
<span class="anchor" id="line-4-1"></span>#</pre><span class="anchor" id="line-170"></span><p class="line874">由第 168 行起 —— <span class="anchor" id="line-171"></span><span class="anchor" id="line-172"></span><span class="anchor" id="line-173"></span><span class="anchor" id="line-174"></span><span class="anchor" id="line-175"></span><span class="anchor" id="line-176"></span><span class="anchor" id="line-177"></span><span class="anchor" id="line-178"></span><span class="anchor" id="line-179"></span><span class="anchor" id="line-180"></span><span class="anchor" id="line-181"></span><span class="anchor" id="line-182"></span><span class="anchor" id="line-183"></span><span class="anchor" id="line-184"></span><span class="anchor" id="line-185"></span><span class="anchor" id="line-186"></span><pre><span class="anchor" id="line-1-20"></span>echo "%files -n kmod-${kmod_name}${dashvariant}"
<span class="anchor" id="line-2-8"></span>
<span class="anchor" id="line-3-4"></span>if [ "" == "$kmp_override_filelist" ];
<span class="anchor" id="line-4-2"></span>then
<span class="anchor" id="line-5-1"></span>    echo "%defattr(644,root,root,755)"
<span class="anchor" id="line-6"></span>    echo "/lib/modules/${verrel}${variant}/"
<span class="anchor" id="line-7"></span>    echo "%config /etc/depmod.d/kmod-${kmod_name}.conf"
<span class="anchor" id="line-8"></span>    #BZ252188 - I've commented this out for the moment since RHEL5 doesn't
<span class="anchor" id="line-9"></span>    # really support external firmware e.g. at install time. If
<span class="anchor" id="line-10"></span>    # you really want it, use an override filelist solution.
<span class="anchor" id="line-11"></span>    #echo "/lib/firmware/"
<span class="anchor" id="line-12"></span>else
<span class="anchor" id="line-13"></span>    cat "$kmp_override_filelist"
<span class="anchor" id="line-14"></span>fi</pre><span class="anchor" id="line-187"></span><p class="line862">7. 在 SPECS 目錄內建立 <tt class="backtick">cifs-kmod.spec</tt> 檔。 <span class="anchor" id="line-188"></span><span class="anchor" id="line-189"></span><p class="line867"><span class="anchor" id="line-190"></span><span class="anchor" id="line-191"></span><span class="anchor" id="line-192"></span><pre><span class="anchor" id="line-1-21"></span>[user@host SOURCES]$ cd ~/rpmbuild/SPECS/
<span class="anchor" id="line-2-9"></span>[user@host SPECS]$ vi cifs-kmod.spec</pre><span class="anchor" id="line-193"></span><p class="line867"><span class="anchor" id="line-194"></span><span class="anchor" id="line-195"></span><span class="anchor" id="line-196"></span><span class="anchor" id="line-197"></span><span class="anchor" id="line-198"></span><span class="anchor" id="line-199"></span><span class="anchor" id="line-200"></span><span class="anchor" id="line-201"></span><span class="anchor" id="line-202"></span><span class="anchor" id="line-203"></span><span class="anchor" id="line-204"></span><span class="anchor" id="line-205"></span><span class="anchor" id="line-206"></span><span class="anchor" id="line-207"></span><span class="anchor" id="line-208"></span><span class="anchor" id="line-209"></span><span class="anchor" id="line-210"></span><span class="anchor" id="line-211"></span><span class="anchor" id="line-212"></span><span class="anchor" id="line-213"></span><span class="anchor" id="line-214"></span><span class="anchor" id="line-215"></span><span class="anchor" id="line-216"></span><span class="anchor" id="line-217"></span><span class="anchor" id="line-218"></span><span class="anchor" id="line-219"></span><span class="anchor" id="line-220"></span><span class="anchor" id="line-221"></span><span class="anchor" id="line-222"></span><span class="anchor" id="line-223"></span><span class="anchor" id="line-224"></span><span class="anchor" id="line-225"></span><span class="anchor" id="line-226"></span><span class="anchor" id="line-227"></span><span class="anchor" id="line-228"></span><span class="anchor" id="line-229"></span><span class="anchor" id="line-230"></span><span class="anchor" id="line-231"></span><span class="anchor" id="line-232"></span><span class="anchor" id="line-233"></span><span class="anchor" id="line-234"></span><span class="anchor" id="line-235"></span><span class="anchor" id="line-236"></span><span class="anchor" id="line-237"></span><span class="anchor" id="line-238"></span><span class="anchor" id="line-239"></span><span class="anchor" id="line-240"></span><span class="anchor" id="line-241"></span><span class="anchor" id="line-242"></span><span class="anchor" id="line-243"></span><span class="anchor" id="line-244"></span><span class="anchor" id="line-245"></span><span class="anchor" id="line-246"></span><span class="anchor" id="line-247"></span><span class="anchor" id="line-248"></span><span class="anchor" id="line-249"></span><span class="anchor" id="line-250"></span><span class="anchor" id="line-251"></span><span class="anchor" id="line-252"></span><span class="anchor" id="line-253"></span><span class="anchor" id="line-254"></span><span class="anchor" id="line-255"></span><span class="anchor" id="line-256"></span><span class="anchor" id="line-257"></span><span class="anchor" id="line-258"></span><span class="anchor" id="line-259"></span><span class="anchor" id="line-260"></span><span class="anchor" id="line-261"></span><span class="anchor" id="line-262"></span><span class="anchor" id="line-263"></span><span class="anchor" id="line-264"></span><span class="anchor" id="line-265"></span><span class="anchor" id="line-266"></span><span class="anchor" id="line-267"></span><span class="anchor" id="line-268"></span><span class="anchor" id="line-269"></span><span class="anchor" id="line-270"></span><span class="anchor" id="line-271"></span><span class="anchor" id="line-272"></span><span class="anchor" id="line-273"></span><span class="anchor" id="line-274"></span><span class="anchor" id="line-275"></span><span class="anchor" id="line-276"></span><span class="anchor" id="line-277"></span><span class="anchor" id="line-278"></span><pre><span class="anchor" id="line-1-22"></span># Define the kmod package name here.
<span class="anchor" id="line-2-10"></span>%define kmod_name cifs
<span class="anchor" id="line-3-5"></span>
<span class="anchor" id="line-4-3"></span># If kversion isn't defined on the rpmbuild line, define it here.
<span class="anchor" id="line-5-2"></span>%{!?kversion: %define kversion 2.6.18-8.el5}
<span class="anchor" id="line-6-1"></span>
<span class="anchor" id="line-7-1"></span>Name:    %{kmod_name}-kmod
<span class="anchor" id="line-8-1"></span>Version: 1.45
<span class="anchor" id="line-9-1"></span>Release: 1%{?dist}
<span class="anchor" id="line-10-1"></span>Group:   System Environment/Kernel
<span class="anchor" id="line-11-1"></span>License: GPLv2
<span class="anchor" id="line-12-1"></span>Summary: %{kmod_name} kernel module(s)
<span class="anchor" id="line-13-1"></span>URL:     http://www.centos.org/
<span class="anchor" id="line-14-1"></span>
<span class="anchor" id="line-15"></span>BuildRequires: redhat-rpm-config
<span class="anchor" id="line-16"></span>BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-build-%(%{__id_u} -n)
<span class="anchor" id="line-17"></span>ExclusiveArch: i686 x86_64
<span class="anchor" id="line-18"></span>
<span class="anchor" id="line-19"></span># Sources.
<span class="anchor" id="line-20"></span>Source0:  %{kmod_name}-%{version}.tar.bz2
<span class="anchor" id="line-21"></span>Source10: kmodtool-%{kmod_name}-el5.sh
<span class="anchor" id="line-22"></span>
<span class="anchor" id="line-23"></span># Define the variants for each architecture.
<span class="anchor" id="line-24"></span>%define basevar ""
<span class="anchor" id="line-25"></span>%ifarch i686
<span class="anchor" id="line-26"></span>%define paevar PAE
<span class="anchor" id="line-27"></span>%endif
<span class="anchor" id="line-28"></span>%ifarch i686 x86_64
<span class="anchor" id="line-29"></span>%define xenvar xen
<span class="anchor" id="line-30"></span>%endif
<span class="anchor" id="line-31"></span>
<span class="anchor" id="line-32"></span># If kvariants isn't defined on the rpmbuild line, build all variants for this architecture.
<span class="anchor" id="line-33"></span>%{!?kvariants: %define kvariants %{?basevar} %{?xenvar} %{?paevar}}
<span class="anchor" id="line-34"></span>
<span class="anchor" id="line-35"></span># Magic hidden here.
<span class="anchor" id="line-36"></span>%{expand:%(sh %{SOURCE10} rpmtemplate_kmp %{kmod_name} %{kversion} %{kvariants})}
<span class="anchor" id="line-37"></span>
<span class="anchor" id="line-38"></span># Disable the building of the debug package(s).
<span class="anchor" id="line-39"></span>%define debug_package %{nil}
<span class="anchor" id="line-40"></span>
<span class="anchor" id="line-41"></span># Define the filter.
<span class="anchor" id="line-42"></span>%define __find_requires sh %{_builddir}/%{buildsubdir}/filter-requires.sh
<span class="anchor" id="line-43"></span>
<span class="anchor" id="line-44"></span>%description
<span class="anchor" id="line-45"></span>This package provides the CentOS-5 bug-fixed %{kmod_name} kernel module (bug #1776).
<span class="anchor" id="line-46"></span>It is built to depend upon the specific ABI provided by a range of releases
<span class="anchor" id="line-47"></span>of the same variant of the Linux kernel and not on any one specific build.
<span class="anchor" id="line-48"></span>
<span class="anchor" id="line-49"></span>%prep
<span class="anchor" id="line-50"></span>%setup -q -c -T -a 0
<span class="anchor" id="line-51"></span>for kvariant in %{kvariants} ; do
<span class="anchor" id="line-52"></span>    %{__cp} -a %{kmod_name}-%{version} _kmod_build_$kvariant
<span class="anchor" id="line-53"></span>done
<span class="anchor" id="line-54"></span>echo "/usr/lib/rpm/redhat/find-requires | %{__sed} -e '/^ksym.*/d'" &gt; filter-requires.sh
<span class="anchor" id="line-55"></span>echo "override %{kmod_name} * weak-updates/%{kmod_name}" &gt; kmod-%{kmod_name}.conf
<span class="anchor" id="line-56"></span>
<span class="anchor" id="line-57"></span>%build
<span class="anchor" id="line-58"></span>for kvariant in %{kvariants} ; do
<span class="anchor" id="line-59"></span>    KSRC=%{_usrsrc}/kernels/%{kversion}${kvariant:+-$kvariant}-%{_target_cpu}
<span class="anchor" id="line-60"></span>    %{__make} -C "${KSRC}" %{?_smp_mflags} modules M=$PWD/_kmod_build_$kvariant
<span class="anchor" id="line-61"></span>done
<span class="anchor" id="line-62"></span>
<span class="anchor" id="line-63"></span>%install
<span class="anchor" id="line-64"></span>%{__rm} -rf %{buildroot}
<span class="anchor" id="line-65"></span>export INSTALL_MOD_PATH=%{buildroot}
<span class="anchor" id="line-66"></span>export INSTALL_MOD_DIR=extra/%{kmod_name}
<span class="anchor" id="line-67"></span>for kvariant in %{kvariants} ; do
<span class="anchor" id="line-68"></span>    KSRC=%{_usrsrc}/kernels/%{kversion}${kvariant:+-$kvariant}-%{_target_cpu}
<span class="anchor" id="line-69"></span>    %{__make} -C "${KSRC}" modules_install M=$PWD/_kmod_build_$kvariant
<span class="anchor" id="line-70"></span>done
<span class="anchor" id="line-71"></span>%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
<span class="anchor" id="line-72"></span>%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
<span class="anchor" id="line-73"></span># Set the module(s) to be executable, so that they will be stripped when packaged.
<span class="anchor" id="line-74"></span>find %{buildroot} -type f -name \*.ko -exec %{__chmod} u+x \{\} \;
<span class="anchor" id="line-75"></span>
<span class="anchor" id="line-76"></span>%clean
<span class="anchor" id="line-77"></span>%{__rm} -rf %{buildroot}
<span class="anchor" id="line-78"></span>
<span class="anchor" id="line-79"></span>%changelog
<span class="anchor" id="line-80"></span>* Wed Jan 05 2011 Alan Bartlett &lt;ajb@elrepo.org&gt; - 1.45
<span class="anchor" id="line-81"></span>- Revised this specification file.
<span class="anchor" id="line-82"></span>
<span class="anchor" id="line-83"></span>* Fri May 18 2007 Akemi Yagi &lt;toracat@centos.org&gt; - 1.45
<span class="anchor" id="line-84"></span>- Initial el5 build of the kmod package.</pre><span class="anchor" id="line-279"></span><p class="line874">8. 建立套件。 <span class="anchor" id="line-280"></span><span class="anchor" id="line-281"></span><p class="line867"><span class="anchor" id="line-282"></span><span class="anchor" id="line-283"></span><pre><span class="anchor" id="line-1-23"></span>[user@host SPECS]$ rpmbuild -bb --target=`uname -m` cifs-kmod.spec 2&gt; build-err.log | tee build-out.log</pre><span class="anchor" id="line-284"></span><p class="line874">你果你不想建立一個對應使用中的內核的 kmod 套件，你可以在指令行上指定內核的版本。例如： <span class="anchor" id="line-285"></span><span class="anchor" id="line-286"></span><p class="line867"><span class="anchor" id="line-287"></span><span class="anchor" id="line-288"></span><pre><span class="anchor" id="line-1-24"></span>[user@host SPECS]$ rpmbuild -bb --target=`uname -m` --define 'kversion 2.6.18-371.el5' cifs-kmod.spec 2&gt; build-err.log | tee build-out.log</pre><span class="anchor" id="line-289"></span><p class="line874">這樣做便會為 2.6.18-371.el5 內核建立 kmod 套件。 <span class="anchor" id="line-290"></span><span class="anchor" id="line-291"></span><p class="line874">在 CentOS 7 及內含 kmodtool 腳本的較新版本，請用以下方式提供內核版本 <span class="anchor" id="line-292"></span><span class="anchor" id="line-293"></span><p class="line867"><span class="anchor" id="line-294"></span><span class="anchor" id="line-295"></span><pre><span class="anchor" id="line-1-25"></span>[user@host SPECS]$ rpmbuild -bb --target=`uname -m` --define 'kernel_version 3.10.0-862.el7' cifs-kmod.spec 2&gt; build-err.log | tee build-out.log</pre><span class="anchor" id="line-296"></span><span class="anchor" id="line-297"></span><p class="line874">這樣做便會為 3.10.0-862.el7 內核建立 kmod 套件。 <span class="anchor" id="line-298"></span><span class="anchor" id="line-299"></span><p class="line874">利用同一個方法，你可以選擇建立哪一個內核類型的 kmod 套件。例如： <span class="anchor" id="line-300"></span><span class="anchor" id="line-301"></span><p class="line867"><span class="anchor" id="line-302"></span><span class="anchor" id="line-303"></span><pre><span class="anchor" id="line-1-26"></span>[user@host SPECS]$ rpmbuild -bb --target=`uname -m` --define 'kvariants ""' cifs-kmod.spec 2&gt; build-err.log | tee build-out.log</pre><span class="anchor" id="line-304"></span><p class="line874">這樣做便只會建立基本內核的 kmod 套件。 <span class="anchor" id="line-305"></span><span class="anchor" id="line-306"></span><p class="line862">當編譯完成後，<tt class="backtick">~/rpmbuild/RPMS/</tt><tt>`uname&nbsp;-m`</tt><tt class="backtick">/</tt> 目錄內將會藏有一套 <tt class="backtick">kmod-cifs</tt> 的 rpm 檔。 <span class="anchor" id="line-307"></span><span class="anchor" id="line-308"></span><p class="line874">請亦參閱： <span class="anchor" id="line-309"></span><span class="anchor" id="line-310"></span><ul><li><p class="line862">以 RHEL 6 為基礎的 Red Hat 驅動程式更新套件官方參考指南 <a class="http" href="http://people.redhat.com/jcm/el6/dup/docs/dup_book.pdf">http://people.redhat.com/jcm/el6/dup/docs/dup_book.pdf</a> <span class="anchor" id="line-311"></span></li><li><p class="line862">Fedora 的建設一般 rpm 文檔 <a class="https" href="https://docs.fedoraproject.org/en-US/quick-docs/creating-rpm-packages/">https://docs.fedoraproject.org/en-US/quick-docs/creating-rpm-packages/</a> <span class="anchor" id="line-312"></span></li><li><p class="line862">已棄用的 Fedora 文檔有關如何建立內核模塊套件，純作參考之用。 <a class="http" href="http://fedoraproject.org/wiki/Obsolete/KernelModules">http://fedoraproject.org/wiki/Obsolete/KernelModules</a> <span class="anchor" id="line-313"></span><span class="anchor" id="line-314"></span></li></ul><p class="line867"><small>Translation of revision 170</small> <span class="anchor" id="line-315"></span><span class="anchor" id="bottom"></span></div>
</div>
<hr>
2023-09-11 07:23
</body>
</html>
